%global unmangled_version 0.33.3

Summary: Reference Synapse Home Server
Name: matrix-synapse
Version: %{unmangled_version}%{?unmangled_release:.%{unmangled_release}}
Release: 2%{?dist}.1
Source0: https://github.com/matrix-org/synapse/archive/v%{unmangled_version}%{?unmangled_release?-r%{unmangled_release}}/synapse-%{unmangled_version}%{?unmangled_release:-r%{unmangled_release}}.tar.gz
Source1: synapse-tmpfile.conf
Source2: synapse.sysconfig
Source3: synapse.service
Patch0: matrix-synapse-proper-paths.patch
Patch2: matrix-synapse-test-paths.patch
# CVE-2018-16515
Patch3: matrix-synapse-sig-check.patch
License: ASL 2.0
Group: Development/Libraries
Prefix: %{_prefix}
BuildArch: noarch
BuildRequires: python2-devel
BuildRequires: python-twisted >= 16.0.0
BuildRequires: python-mock
BuildRequires: python-setuptools_trial
BuildRequires: systemd-units
BuildRequires: python-unpaddedbase64 >= 1.1.0
BuildRequires: python-canonicaljson >= 1.1.3
BuildRequires: python-signedjson >= 1.0.0
BuildRequires: python-syweb >= 0.6.8
BuildRequires: python-service-identity >= 1.0.0
BuildRequires: pyOpenSSL >= 0.15
BuildRequires: python-yaml
BuildRequires: python-pyasn1
BuildRequires: python-pynacl >= 1.2.1
BuildRequires: python-daemonize
BuildRequires: python-bcrypt >= 3.1.0
BuildRequires: python-frozendict >= 0.4
BuildRequires: python-pillow
BuildRequires: python-pydenticon
BuildRequires: python-sortedcontainers
BuildRequires: python-pysaml2 >= 3.0.0
BuildRequires: python-pymacaroons-pynacl
BuildRequires: python-bleach >= 1.4.2
BuildRequires: python-netaddr >= 0.7.18
BuildRequires: python-jinja2 >= 2.8
BuildRequires: python-matrix-synapse-ldap3 >= 0.1
BuildRequires: python-psutil >= 2.0.0
BuildRequires: python-lxml
BuildRequires: python-msgpack
BuildRequires: python-jsonschema >= 2.5.1
BuildRequires: python-phonenumbers >= 8.2.0
BuildRequires: python-affinity
BuildRequires: python-six
BuildRequires: python-prometheus_client
BuildRequires: python-attrs
Requires: python-unpaddedbase64 >= 1.1.0
Requires: python-canonicaljson >= 1.1.3
Requires: python-signedjson >= 1.0.0
Requires: python-syweb >= 0.6.8
Requires: python-twisted >= 16.0.0
Requires: python-service-identity >= 1.0.0
Requires: pyOpenSSL >= 0.15
Requires: python-yaml
Requires: python-pyasn1
Requires: python-pynacl >= 1.2.1
Requires: python-daemonize
Requires: python-bcrypt >= 3.1.0
Requires: python-frozendict >= 0.4
Requires: python-pillow
Requires: python-pydenticon
Requires: python-sortedcontainers
Requires: python-pysaml2 >= 3.0.0
Requires: python-pymacaroons-pynacl
Requires: python-bleach >= 1.4.2
Requires: python-netaddr >= 0.7.18
Requires: python-jinja2 >= 2.8
Requires: python-matrix-synapse-ldap3 >= 0.1
Requires: python-psutil >= 2.0.0
Requires: python-lxml
Requires: python-msgpack
Requires: python-jsonschema >= 2.5.1
Requires: python-phonenumbers >= 8.2.0
Requires: python-affinity
Requires: python-six
Requires: python-prometheus_client
Requires: python-attrs
Requires: python-systemd
%systemd_requires

%description
Matrix is an ambitious new ecosystem for open federated Instant Messaging and
VoIP.  The basics you need to know to get up and running are:

- Everything in Matrix happens in a room.  Rooms are distributed and do not
  exist on any single server.  Rooms can be located using convenience aliases 
  like ``#matrix:matrix.org`` or ``#test:localhost:8448``.

- Matrix user IDs look like ``@matthew:matrix.org`` (although in the future
  you will normally refer to yourself and others using a 3PID: email
  address, phone number, etc rather than manipulating Matrix user IDs)

The overall architecture is::

      client <----> homeserver <=====================> homeserver <----> client
             https://somewhere.org/_matrix      https://elsewhere.net/_matrix

``#matrix:matrix.org`` is the official support room for Matrix, and can be
accessed by the web client at http://matrix.org/beta or via an IRC bridge at
irc://irc.freenode.net/matrix.

Synapse is currently in rapid development, but as of version 0.5 we believe it 
is sufficiently stable to be run as an internet-facing service for real usage!

%prep
%setup -n synapse-%{unmangled_version}%{?unmangled_release?:-r%{unmangled_release}}
%patch0 -p1
%patch2 -p1
%patch3 -p1

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install \
  --install-scripts="%{_libexecdir}/%{name}" \
  --skip-build \
  --single-version-externally-managed \
  -O2 \
  --root="$RPM_BUILD_ROOT" \
  --record=INSTALLED_FILES

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_sbindir}"
%{__ln_s} "%{_libexecdir}/%{name}/synctl" \
          "%{_libexecdir}/%{name}/register_new_matrix_user" \
          "${RPM_BUILD_ROOT}%{_sbindir}"

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_sysconfdir}/synapse"
%{__install} -m 0644 contrib/systemd/log_config.yaml \
             "${RPM_BUILD_ROOT}%{_sysconfdir}/synapse"

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_unitdir}"
%{__install} -m 0644 %{SOURCE3} "${RPM_BUILD_ROOT}%{_unitdir}"

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_prefix}/lib/tmpfiles.d"
%{__install} -m0644 %{SOURCE1} \
             "${RPM_BUILD_ROOT}%{_prefix}/lib/tmpfiles.d/synapse.conf"

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig"
%{__install} -m0644 %{SOURCE2} \
             "${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/synapse"

%{__mkdir_p} "${RPM_BUILD_ROOT}%{_localstatedir}/run/synapse"
%{__mkdir_p} "${RPM_BUILD_ROOT}%{_localstatedir}/lib/synapse"
%{__mkdir_p} "${RPM_BUILD_ROOT}%{_localstatedir}/log/synapse"

%check
PYTHONPATH=. %{_bindir}/trial tests

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group synapse &>/dev/null || groupadd -r synapse
getent passwd synapse &>/dev/null || \
    /usr/sbin/useradd -r -g synapse -s /sbin/nologin -c 'Matrix Synapse' \
        -d %{_localstatedir}/lib/synapse synapse

%post
%systemd_post synapse.service

%preun
%systemd_preun synapse.service

%postun
%systemd_postun_with_restart synapse.service

%files -f INSTALLED_FILES
%defattr(-,root,root)
%doc *.rst
%doc LICENSE
%attr(0710,root,synapse) %dir %{_sysconfdir}/synapse
%config %{_sysconfdir}/synapse/*
%config %{_sysconfdir}/sysconfig/synapse
%{_sbindir}/*
%{_libexecdir}/matrix-synapse/*.py*
%{_unitdir}/synapse.service
%{_prefix}/lib/tmpfiles.d/synapse.conf
%attr(0710,synapse,synapse) %{_localstatedir}/run/synapse
%attr(0710,synapse,synapse) %{_localstatedir}/lib/synapse
%attr(0750,synapse,synapse) %{_localstatedir}/log/synapse
%changelog
* Wed Sep  5 2018 Oleg Girko <ol@infoserver.lv> 0.33.3-2
- Add patch to fix CVE-2018-16515
* Wed Aug 22 2018 Oleg Girko <ol@infoserver.lv> 0.33.3-1
- Update to 0.33.3
* Thu Aug  9 2018 Oleg Girko <ol@infoserver.lv> 0.33.2-1
- Update to 0.33.2
* Fri Aug  3 2018 Oleg Girko <ol@infoserver.lv> 0.33.1-1
- Update to 0.33.1
* Sat Jul 21 2018 Oleg Girko <ol@infoserver.lv> 0.33.0-1
- Update to 0.33.0
* Sat Jul  7 2018 Oleg Girko <ol@infoserver.lv> 0.32.2-1
- Update to 0.32.2
* Fri Jul  6 2018 Oleg Girko <ol@infoserver.lv> 0.32.0-1
- Update to 0.32.0
* Tue Jun 26 2018 Oleg Girko <ol@infoserver.lv> 0.31.2-1
- Update to 0.31.2
* Sat Jun  9 2018 Oleg Girko <ol@infoserver.lv> 0.31.1-1
- Update to 0.31.1
* Wed Jun  6 2018 Oleg Girko <ol@infoserver.lv> 0.31.0-1
- Update to 0.31.0
- Use python2 instead of python for build and install
* Thu May 24 2018 Oleg Girko <ol@infoserver.lv> 0.30.0-1
- Update to 0.30.0
* Wed May 16 2018 Oleg Girko <ol@infoserver.lv> 0.29.0-1
- Update to 0.29.0
- Use our own systemd unit file, not rely on the one from contrib
* Tue May  1 2018 Oleg Girko <ol@infoserver.lv> 0.28.1-1
- Update to 0.28.1
* Fri Apr 27 2018 Oleg Girko <ol@infoserver.lv> 0.28.0-1
- Update to 0.28.0
* Fri Apr 13 2018 Oleg Girko <ol@infoserver.lv> 0.27.4-1
- Update to 0.27.4
* Wed Apr 11 2018 Oleg Girko <ol@infoserver.lv> 0.27.3-1
- Update to 0.27.3
* Mon Mar 26 2018 Oleg Girko <ol@infoserver.lv> 0.27.2-1
- Update to 0.27.2
* Thu Nov 16 2017 Oleg Girko <ol@infoserver.lv> 0.25.0-1
- Update to 0.25.0
* Tue Oct 24 2017 Oleg Girko <ol@infoserver.lv> 0.24.1-1
- Update to 0.24.1
* Mon Oct 23 2017 Oleg Girko <ol@infoserver.lv> 0.24.0-1
- Update to 0.24.0
* Tue Oct 17 2017 Oleg Girko <ol@infoserver.lv> 0.23.1-1
- Update to 0.23.1
* Mon Oct  2 2017 Oleg Girko <ol@infoserver.lv> 0.23.0-1
- Update to 0.23.0
* Fri Jul  7 2017 Oleg Girko <ol@infoserver.lv> 0.22.1-1
- Update to 0.22.1
* Thu Jun 15 2017 Oleg Girko <ol@infoserver.lv> 0.21.1-1
- Update to 0.21.1
* Thu May 18 2017 Oleg Girko <ol@infoserver.lv> 0.21.0-1
- Update to 0.21.0
* Tue Apr 11 2017 Oleg Girko <ol@infoserver.lv> 0.20.0-1
- Update to 0.20.0
* Tue Mar 21 2017 Oleg Girko <ol@infoserver.lv> 0.19.3-1
- Update to 0.19.3
* Tue Mar 14 2017 Oleg Girko <ol@infoserver.lv> 0.19.2-2
- Allow newer pynacl to be used with Synapse
* Tue Feb 21 2017 Oleg Girko <ol@infoserver.lv> 0.19.2-1
- Update to 0.19.2
* Thu Feb  9 2017 Oleg Girko <ol@infoserver.lv> 0.19.1-1
- Update to 0.19.1
* Mon Jan  9 2017 Oleg Girko <ol@infoserver.lv> 0.18.7-1
- Update to 0.18.7
* Fri Jan  6 2017 Oleg Girko <ol@infoserver.lv> 0.18.6-1
- Update to 0.18.6
* Tue Dec 27 2016 Oleg Girko <ol@infoserver.lv> 0.18.5-1
- Update to 0.18.5
- Run tests proper way using trial
* Tue Nov 22 2016 Oleg Girko <ol@infoserver.lv> 0.18.4-1
- Update to 0.18.4
* Tue Nov  8 2016 Oleg Girko <ol@infoserver.lv> 0.18.3-1
- Update to 0.18.3
* Wed Nov  2 2016 Oleg Girko <ol@infoserver.lv> 0.18.2-1
- Update to 0.18.2
* Wed Oct  5 2016 Oleg Girko <ol@infoserver.lv> 0.18.1-1
- Update to 0.18.1
* Mon Sep 19 2016 Oleg Girko <ol@infoserver.lv> 0.18.0-1
- Update to 0.18.0
* Fri Sep  9 2016 Oleg Girko <ol@infoserver.lv> 0.17.3-1
- Update to 0.17.3
* Thu Sep  8 2016 Oleg Girko <ol@infoserver.lv> 0.17.2-1
- Update to 0.17.2
* Wed Aug 24 2016 Oleg Girko <ol@infoserver.lv> 0.17.1-1
- Update to 0.17.1
- Require python-lxml for web page preview support
* Mon Aug  8 2016 Oleg Girko <ol@infoserver.lv> 0.17.0-1
- Update to 0.17.0
* Fri Jul  8 2016 Oleg Girko <ol@infoserver.lv> 0.16.1-2
- Add security fix
* Mon Jun 20 2016 Oleg Girko <ol@infoserver.lv> 0.16.1-1
- Update to 0.16.1
* Thu Jun  9 2016 Oleg Girko <ol@infoserver.lv> 0.16.0-1
- Update to 0.16.0
* Thu Mar 31 2016 Oleg Girko <ol@infoserver.lv> 0.14.0-2
- Add environment file to systemd unit configuration
* Wed Mar 30 2016 Oleg Girko <ol@infoserver.lv> 0.14.0-1
- Update to 0.14.0
* Sun Mar  6 2016 Oleg Girko <ol@infoserver.lv> 0.13.3-2
- Require python-systemd explicitly for systemd logging
* Thu Feb 11 2016 Oleg Girko <ol@infoserver.lv> 0.13.3-1
- Update to 0.13.3
* Fri Jan 22 2016 Oleg Girko <ol@infoserver.lv> 0.12.0-1
- Update to 0.12.0
* Sat Nov 28 2015 Oleg Girko <ol@infoserver.lv> 0.11.1-1
- Update to 0.11.1
* Thu Nov  5 2015 Oleg Girko <ol@infoserver.lv> 0.10.0.2-3
- Fix patch to use proper paths
* Thu Nov  5 2015 Oleg Girko <ol@infoserver.lv> 0.10.0.2-2
- Fix python-twisted dependency
* Wed Nov  4 2015 Oleg Girko <ol@infoserver.lv> 0.10.0.2-1
- Update to 0.10.0-r2
* Mon Jul 13 2015 Oleg Girko <ol@infoserver.lv> 0.9.3-1
- Initial package
